﻿﻿'use strict';

define(['backbone.pageable', 'System/Logs/LogsModel'],
    function (PagableCollection, LogsModel) {
    return PagableCollection.extend({
        url  : window.NzbDrone.ApiRoot + '/log',
        model: LogsModel,

        state: {
            pageSize: 50,
            sortKey : 'time',
            order   : 1
        },

        queryParams: {
            totalPages  : null,
            totalRecords: null,
            pageSize    : 'pageSize',
            sortKey     : 'sortKey',
            order       : 'sortDir',
            directions  : {
                '-1': 'asc',
                '1' : 'desc'
            }
        },

        parseState: function (resp, queryParams, state) {
            return {totalRecords: resp.totalRecords};
        },

        parseRecords: function (resp) {
            if (resp) {
                return resp.records;
            }

            return resp;
        }
    });
});
